//+------------------------------------------------------------------+
//|                                                     MACD_Roc.mq4 |
//|                                        Copyright  2010, skipper |
//|                                http://metallizzato.blogspot.com/ |
//|                                                                  |
//|                                             adapted from ROC.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
#property  copyright "Copyright  2010, skipper"
#property  link      "http://metallizzato.blogspot.com/"

//+------------------------------------------------------------------+
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Lime
#property  indicator_color2  Red

//---- indicator parameters
extern string s1 = "Media breve e tipo";
extern int MAShort=13;
extern int MaShortType=3;     //valori ammessi: 0, 1, 2, 3 (SMA, EMA, SMMA, LWMA)
extern string s2 = "Media lunga e tipo";
extern int MALong=21;
extern int MaLongType=3;      //valori ammessi: 0, 1, 2, 3 (SMA, EMA, SMMA, LWMA)
extern string s3 = "Distanza periodo precedente";
extern int RocSpeed=5;
extern string s4 = "Lunghezza e tipo di media del segnale";
extern int SignalLength = 3;
extern int SignalType = 0;  //valori ammessi: 0, 1, 2, 3 (SMA, EMA, SMMA, LWMA)

//---- indicator buffers
double     RateOfChange[];
double     SignalBuffer[];
double     MacdBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexDrawBegin(0,MAShort);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   SetIndexDrawBegin(1,MALong + SignalLength);

   //IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
//---- indicator buffers mapping
   if(!SetIndexBuffer(0,RateOfChange))
      Print("cannot set indicator buffers!");
   if(!SetIndexBuffer(1,SignalBuffer))
      Print("cannot set indicator buffers!");
   if(!SetIndexBuffer(2,MacdBuffer))
      Print("cannot set indicator buffers!");

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MacdRoc("+MAShort+", "+MaShortType+", "+MALong+", "+MaLongType+", "+RocSpeed+", "+SignalLength+", "+SignalType+")");
   SetIndexLabel(0,"MacdRoc");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int i, limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
//---- macdbuffer
   for(i=0; i<limit; i++)
      MacdBuffer[i]=iMA(NULL,0,MAShort,0,MaShortType,PRICE_CLOSE,i)-iMA(NULL,0,MALong,0,MaLongType,PRICE_CLOSE,i);

//----ROC of MACD
   //limit = limit - RocSpeed;   
   for(i=0; i<limit; i++)
   {
      RateOfChange[i]=MacdBuffer[i] - MacdBuffer[i+RocSpeed];
   }
//----Signal Line of MACD
   for(i=0; i<limit; i++) SignalBuffer[i]=iMAOnArray(RateOfChange,0,SignalLength,0,SignalType,i);   
   
//---- done
   return(0);
  }